{-
This module defines the Haskell functions data types, seen as macros, and 
to be passed trough the cpp before becoming Haskell valid
-}


module FunctionTypes where

import List

{--}

data Target = Haskell
	    | OCaml
	    deriving (Eq,Read)

type Functions = [Function]


{-
For example, the function

#define eq_Fork_1_m(AO_Fork_1_m,AO_Fork_2_m) (min AO_Fork_1_m AO_Fork_2_m) 

would be represented, in Haskell, by

Function "Fork_1_m"
	 "min"
	 ["Fork_1_m",
	  "Fork_2_m"]
-}

data Function  = Function
			Occurence
			FunctionName
			[FunctionArgument]
	deriving Eq

instance Show Function 
	where
	 show (Function oc
		        fn
		        lfas) = let lfas' = map ("A0_"++) lfas
				in  
				"#define eq_"
			      ++ oc
			      ++ "("
			      ++ concat (intersperse "," lfas')
			      ++ space ")"
			      ++ "("
		 	      ++ space fn
			      ++ concat (intersperse " " lfas')
			      ++ newLine ")"

type Occurence        = String
type FunctionName     = String
type FunctionArgument = String 

space x   = x ++ " "
newLine x = x ++ "\n"
