module Main where

import List

import Haskell2FunctionsAndAgtEquations
import FunctionTypes

import Language.Haskell.Syntax
import Language.Haskell.Parser
import Language.Haskell.Pretty

import ML_Parser

import System

import Debug.Trace

main = do [progname,target] <- getArgs
	  circ       <- readFile progname
	  target'    <- return $ ((read target) :: Target)
	  let ((agt,fs),nt,pb) = if (last2 progname == "hs") 
					then haskell2Agt_Functions target' (f (parseModule circ))
					else haskell2Agt_Functions target' ((fst.head.(filter ((=="").snd)).parseML) circ)
	  if (target'==Haskell) then do writeFile "non_treated" ((if (nt /= [] || pb /= []) 
							          then "\n\n-- original Module not analysed functions\n\n" 
							          else "")
							       ++ (concatMap ((++"\n").prettyPrint) nt)
							       ++ (concatMap ((++"\n").prettyPrint) pb))
				        writeFile "AgtFiles/Save.agt"	 (show agt)
				        writeFile "AgtFiles/haskell.eqs" (concatMap show fs)
				else do writeFile "AgtFiles/Save.agt"    (show agt)
				        writeFile "AgtFiles/ocaml.eqs"	 (concatMap show fs)


f (ParseOk x) = x

last2 []    = error "Invalid Module Name"
last2 [a,b] = [a,b]
last2 (h:t) = last2 t 
