(*
 * ML-based Visit Tree Visit-Functions
 *)

let rec visit_t_Id_1 t = match t with
   C_Ident_1 (t_STR_1) ->
        ()

and visit_t_It_1 t x_lev x_dcli = match t with
   C_Block_1 (t_Its_1) ->
        let x_lev_1 = (plusOne x_lev) in
        let x_dclo = x_dcli in
        (C_Block_2 (x_lev_1,t_Its_1) , x_dclo)
  | C_Decl_1 (t_Id_1) ->
        let x_errors = ((function x -> function y -> function z -> mNBIn(x,y,z)) t_Id_1 x_lev x_dcli) in
        let x_dclo = ((function x -> function y -> function z -> head (Tuple(x,y), z)) t_Id_1 x_lev x_dcli) in
        (C_Decl_2 (x_errors) , x_dclo)
  | C_Use_1 (t_Id_1) ->
        let x_dclo = x_dcli in
        (C_Use_2 (t_Id_1) , x_dclo)

and visit_t_It_2 t x_env = match t with
   C_Block_2 (x_lev_1,t_Its_1) ->
        let x_dcli_1 = x_env in
        let (t_Its_2,x_dclo_1) = visit_t_Its_1 t_Its_1 x_lev_1 x_dcli_1 in
        let x_env_1 = x_dclo_1 in
        let (x_errors_1) = visit_t_Its_2 t_Its_2 x_env_1 in
        let x_errors = x_errors_1 in
        (x_errors)
  | C_Decl_2 (x_errors) ->
        (x_errors)
  | C_Use_2 (t_Id_1) ->
        let x_errors = ((function x -> function y -> mBIn(x,y)) t_Id_1 x_env) in
        (x_errors)

and visit_t_Its_1 t x_lev x_dcli = match t with
   C_ConsIts_1 (t_It_1,t_Its_2_1) ->
        let x_lev_1 = x_lev in
        let x_lev_2 = x_lev in
        let x_dcli_1 = x_dcli in
        let (t_It_2,x_dclo_1) = visit_t_It_1 t_It_1 x_lev_1 x_dcli_1 in
        let x_dcli_2 = x_dclo_1 in
        let (t_Its_2_2,x_dclo_2) = visit_t_Its_1 t_Its_2_1 x_lev_2 x_dcli_2 in
        let x_dclo = x_dclo_2 in
        (C_ConsIts_2 (t_It_2,t_Its_2_2) , x_dclo)
  | C_NilIts_1 ->
        let x_dclo = x_dcli in
        (C_NilIts_2 , x_dclo)

and visit_t_Its_2 t x_env = match t with
   C_ConsIts_2 (t_It_2,t_Its_2_2) ->
        let x_env_1 = x_env in
        let (x_errors_1) = visit_t_It_2 t_It_2 x_env_1 in
        let x_env_2 = x_env in
        let (x_errors_2) = visit_t_Its_2 t_Its_2_2 x_env_2 in
        let x_errors = ((function x -> function y -> concat(x,y)) x_errors_1 x_errors_2) in
        (x_errors)
  | C_NilIts_2 ->
        let x_errors = ([] ) in
        (x_errors)

and visit_t_P_1 t = match t with
   C_Root_1 (t_Its_1) ->
        let x_dcli_1 = ([] ) in
        let x_lev_1 = (0 ) in
        let (t_Its_2,x_dclo_1) = visit_t_Its_1 t_Its_1 x_lev_1 x_dcli_1 in
        let x_env_1 = x_dclo_1 in
        let (x_errors_1) = visit_t_Its_2 t_Its_2 x_env_1 in
        let x_errors = x_errors_1 in
        (x_errors)

let lrcEval = visit_t_P_1
